tests: fix test_auto_source_discovery on mingw
[babeltrace.git] / tests / utils / utils.sh
index c44e2e3ba12833e94789ab1be99831ab5b04d9bd..69fb84714a72469095f014fb9b988bc88c3dbab5 100644 (file)
 # Error out when encountering an undefined variable
 set -u
 
+# If "readlink -f" is available, get a resolved absolute path to the
+# tests source dir, otherwise make do with a relative path.
 scriptdir="$(dirname "${BASH_SOURCE[0]}")"
+if readlink -f "." >/dev/null 2>&1; then
+       testsdir=$(readlink -f "$scriptdir/..")
+else
+       testsdir="$scriptdir/.."
+fi
+
+# The OS on which we are running. See [1] for possible values of 'uname -s'.
+# We do a bit of translation to ease our life down the road for comparison.
+# Export it so that called executables can use it.
+# [1] https://en.wikipedia.org/wiki/Uname#Examples
+if [ "x${BT_OS_TYPE:-}" = "x" ]; then
+       BT_OS_TYPE="$(uname -s)"
+       case "$BT_OS_TYPE" in
+       MINGW*)
+               BT_OS_TYPE="mingw"
+               ;;
+       Darwin)
+               BT_OS_TYPE="darwin"
+               ;;
+       Linux)
+               BT_OS_TYPE="linux"
+               ;;
+       CYGWIN*)
+               BT_OS_TYPE="cygwin"
+               ;;
+       *)
+               BT_OS_TYPE="unsupported"
+               ;;
+       esac
+fi
+export BT_OS_TYPE
 
 # Allow overriding the source and build directories
 if [ "x${BT_TESTS_SRCDIR:-}" = "x" ]; then
-       BT_TESTS_SRCDIR="$scriptdir/.."
+       BT_TESTS_SRCDIR="$testsdir"
 fi
 export BT_TESTS_SRCDIR
 
 if [ "x${BT_TESTS_BUILDDIR:-}" = "x" ]; then
-       BT_TESTS_BUILDDIR="$scriptdir/.."
+       BT_TESTS_BUILDDIR="$testsdir"
 fi
 export BT_TESTS_BUILDDIR
 
@@ -39,17 +72,24 @@ export BT_TESTS_BUILDDIR
 # the test script, define the 'SH_TAP' variable to '1' before sourcing this
 # script.
 if [ "x${SH_TAP:-}" = x1 ]; then
+       # shellcheck source=./tap/tap.sh
        . "${BT_TESTS_SRCDIR}/utils/tap/tap.sh"
 fi
 
 # Allow overriding the babeltrace2 executables
 if [ "x${BT_TESTS_BT2_BIN:-}" = "x" ]; then
        BT_TESTS_BT2_BIN="$BT_TESTS_BUILDDIR/../src/cli/babeltrace2"
+       if [ "$BT_OS_TYPE" = "mingw" ]; then
+               BT_TESTS_BT2_BIN="${BT_TESTS_BT2_BIN}.exe"
+       fi
 fi
 export BT_TESTS_BT2_BIN
 
 if [ "x${BT_TESTS_BT2LOG_BIN:-}" = "x" ]; then
        BT_TESTS_BT2LOG_BIN="$BT_TESTS_BUILDDIR/../src/cli/babeltrace2-log"
+       if [ "$BT_OS_TYPE" = "mingw" ]; then
+               BT_TESTS_BT2LOG_BIN="${BT_TESTS_BT2LOG_BIN}.exe"
+       fi
 fi
 export BT_TESTS_BT2LOG_BIN
 
@@ -61,6 +101,10 @@ if [ "x${BT_TESTS_BABELTRACE_PLUGIN_PATH:-}" = "x" ]; then
        BT_TESTS_BABELTRACE_PLUGIN_PATH="${BT_PLUGINS_PATH}/ctf:${BT_PLUGINS_PATH}/utils:${BT_PLUGINS_PATH}/text"
 fi
 
+if [ "x${BT_TESTS_PROVIDER_DIR:-}" = "x" ]; then
+       BT_TESTS_PROVIDER_DIR="${BT_TESTS_BUILDDIR}/../src/python-plugin-provider/.libs"
+fi
+
 # Allow overriding the babeltrace2 executables
 if [ "x${BT_TESTS_PYTHONPATH:-}" = "x" ]; then
        BT_TESTS_PYTHONPATH="${BT_TESTS_BUILDDIR}/../src/bindings/python/bt2/build/build_lib"
@@ -83,6 +127,11 @@ if [ "x${BT_TESTS_PYTHON_BIN:-}" = "x" ]; then
 fi
 export BT_TESTS_PYTHON_BIN
 
+if [ "x${BT_TESTS_PYTHON_CONFIG_BIN:-}" = "x" ]; then
+       BT_TESTS_PYTHON_CONFIG_BIN="python3-config"
+fi
+export BT_TESTS_PYTHON_BIN
+
 if [ "x${BT_TESTS_SED_BIN:-}" = "x" ]; then
        BT_TESTS_SED_BIN="sed"
 fi
@@ -92,65 +141,155 @@ export BT_TESTS_SED_BIN
 # Data files path
 BT_TESTS_DATADIR="${BT_TESTS_SRCDIR}/data"
 BT_CTF_TRACES_PATH="${BT_TESTS_DATADIR}/ctf-traces"
-BT_DEBUG_INFO_PATH="${BT_TESTS_DATADIR}/debug-info"
 
 
 ### Diff Functions ###
 
-# Checks the difference between:
+# Checks the difference between stdout:
+#
+#   The file with path "$1", and the file with path "$2"
 #
-# 1. What the CLI outputs when given the arguments "$1" (passed to
-#    `xargs`, so they can include quoted arguments).
-# 2. The file with path "$2".
+# And the difference between stderr:
+#
+#   The file with path "$3", and the file with path "$4"
 #
 # Returns 0 if there's no difference, and 1 if there is, also printing
-# said difference to the standard error.
-bt_diff_cli() {
-       local args="$1"
-       local expected_file="$2"
-       local temp_output_file
-       local temp_diff
+# said difference to the standard error, and an error message with the
+# args starting at "$5".
+bt_diff() {
+       local expected_stdout_file="$1"
+       local actual_stdout_file="$2"
+       local expected_stderr_file="$3"
+       local actual_stderr_file="$4"
+       shift 4
+       local args=("$@")
+
        local ret=0
+       local temp_diff
+
+       temp_diff="$(mktemp -t diff.XXXXXX)"
 
-       temp_output_file="$(mktemp)"
-       temp_diff="$(mktemp)"
+       # Strip any \r present due to Windows (\n -> \r\n).
+       # "diff --string-trailing-cr" is not used since it is not present on
+       # Solaris.
+       "$BT_TESTS_SED_BIN" -i 's/\r//g' "$actual_stdout_file"
+       "$BT_TESTS_SED_BIN" -i 's/\r//g' "$actual_stderr_file"
 
-       # Run the CLI to get a detailed file. Strip any \r present due to
-       # Windows (\n -> \r\n). "diff --string-trailing-cr" is not used since it
-       # is not present on Solaris.
-       echo "$args" | xargs "$BT_TESTS_BT2_BIN" 2>/dev/null | tr -d "\r" > "$temp_output_file"
+       # Compare stdout output with expected stdout output
+       if ! diff -u "$actual_stdout_file" "$expected_stdout_file" 2>/dev/null >"$temp_diff"; then
+               echo "ERROR: for '${args[*]}': actual standard output and expected output differ:" >&2
+               cat "$temp_diff" >&2
+               ret=1
+       fi
 
-       # Compare output with expected output
-       if ! diff "$temp_output_file" "$expected_file" 2>/dev/null >"$temp_diff"; then
-               echo "ERROR: for '$args': actual and expected outputs differ:" >&2
+       # Compare stderr output with expected stderr output
+       if ! diff -u "$actual_stderr_file" "$expected_stderr_file" 2>/dev/null >"$temp_diff"; then
+               echo "ERROR: for '${args[*]}': actual standard error and expected error differ:" >&2
                cat "$temp_diff" >&2
                ret=1
        fi
 
-       rm -f "$temp_output_file" "$temp_diff"
+       rm -f "$temp_diff"
+
+       return $ret
+}
+
+# Checks the difference between:
+#
+#   1. What the CLI outputs on its standard output when given the arguments
+#   "$@" (excluding the first two arguments).
+#   2. The file with path "$1".
+#
+# And the difference between:
+#
+#   1. What the CLI outputs on its standard error when given the arguments
+#   "$@" (excluding the first two arguments).
+#   2. The file with path "$2".
+#
+# Returns 0 if there's no difference, and 1 if there is, also printing
+# said difference to the standard error.
+bt_diff_cli() {
+       local expected_stdout_file="$1"
+       local expected_stderr_file="$2"
+       shift 2
+       local args=("$@")
+
+       local temp_stdout_output_file
+       local temp_stderr_output_file
+       local ret=0
+
+       temp_stdout_output_file="$(mktemp -t actual_stdout.XXXXXX)"
+       temp_stderr_output_file="$(mktemp -t actual_stderr.XXXXXX)"
+
+       # Run the CLI to get a detailed file.
+       run_python_bt2 "$BT_TESTS_BT2_BIN" "${args[@]}" 1>"$temp_stdout_output_file" 2>"$temp_stderr_output_file"
+
+       bt_diff "$expected_stdout_file" "$temp_stdout_output_file" "$expected_stderr_file" "$temp_stderr_output_file" "${args[@]}"
+       ret=$?
+
+       rm -f "$temp_stdout_output_file" "$temp_stderr_output_file"
 
        return $ret
 }
 
 # Checks the difference between:
 #
-# 1. What the CLI outputs when given the arguments:
+#   1. What the CLI outputs on its standard output when given the arguments
+#   "$@" (excluding the first two arguments), sorted with the default "sort".
+#   2. The file with path "$1".
 #
-#        "$1" -c sink.text.details $3
+# And the difference between:
 #
-# 2. The file with path "$2".
+#   1. What the CLI outputs on its standard error when given the arguments
+#   "$@" (excluding the first two arguments).
+#   2. The file with path "$2".
 #
-# Parameter 3 is optional.
+# Returns 0 if there's no difference, and 1 if there is, also printing
+# said difference to the standard error.
+bt_diff_cli_sorted() {
+       local expected_stdout_file="$1"
+       local expected_stderr_file="$2"
+       shift 2
+       local args=("$@")
+
+       local temp_stdout_output_file
+       local temp_stderr_output_file
+       local ret=0
+
+       temp_stdout_output_file="$(mktemp -t actual_stdout.XXXXXX)"
+       temp_stderr_output_file="$(mktemp -t actual_stderr.XXXXXX)"
+
+       # Run the CLI to get a detailed file.
+       run_python_bt2 "$BT_TESTS_BT2_BIN" "${args[@]}" 1>"$temp_stdout_output_file" 2>"$temp_stderr_output_file"
+
+       # Sort the stdout file, use a subshell to do it in-place
+       # shellcheck disable=SC2005
+       echo "$(LC_ALL=C sort "$temp_stdout_output_file")" > "$temp_stdout_output_file"
+
+       bt_diff "$expected_stdout_file" "$temp_stdout_output_file" "$expected_stderr_file" "$temp_stderr_output_file" "${args[@]}"
+       ret=$?
+
+       rm -f "$temp_stdout_output_file" "$temp_stderr_output_file"
+
+       return $ret
+}
+
+# Checks the difference between the content of the file with path "$1"
+# and the output of the CLI when called on the directory path "$2" with
+# the arguments '-c sink.text.details' and the rest of the arguments to
+# this function.
 #
 # Returns 0 if there's no difference, and 1 if there is, also printing
 # said difference to the standard error.
 bt_diff_details_ctf_single() {
-       local trace_dir="$1"
-       local expected_file="$2"
-       local extra_details_args="${3:-}"
+       local expected_stdout_file="$1"
+       local trace_dir="$2"
+       shift 2
+       local extra_details_args=("$@")
+       expected_stderr_file="/dev/null"
 
        # Compare using the CLI with `sink.text.details`
-       bt_diff_cli "\"$trace_dir\" -c sink.text.details $extra_details_args" "$expected_file"
+       bt_diff_cli "$expected_stdout_file" "$expected_stderr_file" "$trace_dir" "-c" "sink.text.details" "${extra_details_args[@]}"
 }
 
 # Calls bt_diff_details_ctf_single(), except that "$1" is the path to a
@@ -159,8 +298,9 @@ bt_diff_details_ctf_single() {
 # CTF trace as its first argument.
 bt_diff_details_ctf_gen_single() {
        local ctf_gen_prog_path="$1"
-       local expected_file="$2"
-       local extra_details_args="${3:-}"
+       local expected_stdout_file="$2"
+       shift 2
+       local extra_details_args=("$@")
 
        local temp_trace_dir
        local ret
@@ -175,7 +315,7 @@ bt_diff_details_ctf_gen_single() {
        fi
 
        # Compare using the CLI with `sink.text.details`
-       bt_diff_details_ctf_single "$temp_trace_dir" "$expected_file" "$extra_details_args"
+       bt_diff_details_ctf_single "$expected_stdout_file" "$temp_trace_dir" "${extra_details_args[@]}"
        ret=$?
        rm -rf "$temp_trace_dir"
        return $ret
@@ -191,40 +331,45 @@ check_coverage() {
 # Execute a shell command in the appropriate environment to have access to the
 # bt2 Python bindings.
 run_python_bt2() {
-       local lib_search_var
-       local lib_search_path
+       local env_args
+
+       env_args=(
+               "BABELTRACE_PYTHON_BT2_NO_TRACEBACK=1" \
+               "BABELTRACE_PLUGIN_PATH=${BT_TESTS_BABELTRACE_PLUGIN_PATH}" \
+               "LIBBABELTRACE2_PLUGIN_PROVIDER_DIR=${BT_TESTS_PROVIDER_DIR}" \
+               "BT_CTF_TRACES_PATH=${BT_CTF_TRACES_PATH}" \
+               "BT_PLUGINS_PATH=${BT_PLUGINS_PATH}" \
+               "PYTHONPATH=${BT_TESTS_PYTHONPATH}:${BT_TESTS_SRCDIR}/utils/python"
+               )
+
+       local main_lib_path="${BT_TESTS_BUILDDIR}/../src/lib/.libs"
 
        # Set the library search path so the python interpreter can load libbabeltrace2
-       if [ "x${MSYSTEM:-}" != "x" ]; then
-               lib_search_var="PATH"
-               lib_search_path="${BT_TESTS_BUILDDIR}/../src/lib/.libs:${PATH:-}"
+       if [ "$BT_OS_TYPE" = "mingw" ] || [ "$BT_OS_TYPE" = "cygwin" ]; then
+               env_args+=("PATH=${main_lib_path}:${PATH:-}")
+       elif [ "$BT_OS_TYPE" = "darwin" ]; then
+               env_args+=("DYLD_LIBRARY_PATH=${main_lib_path}:${DYLD_LIBRARY_PATH:-}")
        else
-               lib_search_var="LD_LIBRARY_PATH"
-               lib_search_path="${BT_TESTS_BUILDDIR}/../src/lib/.libs:${LD_LIBRARY_PATH:-}"
+               env_args+=("LD_LIBRARY_PATH=${main_lib_path}:${LD_LIBRARY_PATH:-}")
        fi
-       if [ "x${test_lib_search_path:-}" != "x" ]; then
-               lib_search_path+=":${test_lib_search_path}"
+
+       # On Windows, an embedded Python interpreter needs a way to locate the path
+       # to it's internal modules, set the prefix from python-config to the
+       # PYTHONHOME variable.
+       if [ "$BT_OS_TYPE" = "mingw" ]; then
+               env_args+=("PYTHONHOME=$($BT_TESTS_PYTHON_CONFIG_BIN --prefix)")
        fi
 
-       env \
-               BABELTRACE_PYTHON_BT2_NO_TRACEBACK=1 \
-               BABELTRACE_PLUGIN_PATH="${BT_TESTS_BABELTRACE_PLUGIN_PATH}" \
-               BT_CTF_TRACES_PATH="${BT_CTF_TRACES_PATH}" \
-               BT_PLUGINS_PATH="${BT_PLUGINS_PATH}" \
-               PYTHONPATH="${BT_TESTS_PYTHONPATH}:${BT_TESTS_SRCDIR}/utils/python" \
-               "${lib_search_var}"="${lib_search_path}" \
-               "$@"
+       env "${env_args[@]}" "$@"
 }
 
 # Set the environment and run python tests in the directory.
 #
 # $1 : The directory containing the python test scripts
 # $2 : The pattern to match python test script names (optional)
-# $3 : Additionnal library search path (optional)
 run_python_bt2_test() {
        local test_dir="$1"
-       local test_pattern="${2:-}" # optional
-       local test_lib_search_path="${3:-}" # optional
+       local test_pattern="${2:-'*'}" # optional, if none default to "*"
 
        local ret
        local test_runner_args=()
@@ -243,7 +388,9 @@ run_python_bt2_test() {
        run_python_bt2 \
                "${python_exec}" \
                "${BT_TESTS_SRCDIR}/utils/python/testrunner.py" \
-               "${test_runner_args[@]}"
+               --pattern "$test_pattern" \
+               "$test_dir" \
+
        ret=$?
 
        if test "x${BT_TESTS_COVERAGE_REPORT:-}" = "x1"; then
This page took 0.028065 seconds and 4 git commands to generate.